/* Wordsearch, Copyright 1996, Eric C Harshbarger.
This code is available for public use and modification as long as this notice of copyright is kept in tact. Additional credit is allowable for modifications.

Documentation on this applet may be found at:
http://www.auburn.edu/~harshec/WWW/slideshow.html

Questions or comments should be directed to:

Eric Harshbarger ( http://www.auburn.edu/~harshec/ )
harshec@mail.auburn.edu   OR    harshec@cdware.eng.sun.com   */

import java.applet.*;
import java.awt.*;
import java.util.StringTokenizer;
import java.util.Vector;
import java.lang.Math;
import java.lang.String;
import java.util.Hashtable;
import java.net.URL;
import sun.net.*;
import java.awt.image.*;
import java.net.MalformedURLException;

public class Wordsearch1 extends Applet implements Runnable {
	
	Image bufimage;
	Graphics bufgraphic;
	Dimension roo;
	int gridsize;
	int squaresize = 22;
	int loopsize = 16;
	int fontsize = 13;
	int drawnloop[][];
	int number = 0;
	int tmploopx1,tmploopx2;
	int tmploopy1,tmploopy2;
	int attempts = 0;
	int px,py,dx,dy;
	int n,ne,e,se,s,sw,w,nw;
	int loopcount = 0;
	String wordlist;
	String words[];
	String placedwords[];
	boolean foundwords[];
	boolean loopstart = false;
	boolean soundoff =true;
	boolean blah = false;
	String entry[][];
	String title;
	AudioClip noword;
	AudioClip win;


	public void run() {
		repaint();
	}

	public void init() {
		String param;
		StringTokenizer st;

		n=ne=e=se=s=sw=w=nw=0;
		try {
			noword = getAudioClip(new URL("http://www.auburn.edu/~harshec/WWW/audio/noword.au"));
		} catch ( Exception e ) {}

		try {
			win = getAudioClip(new URL("http://www.auburn.edu/~harshec/WWW/audio/win.au"));
		} catch ( Exception e ) {}

		gridsize = (getParameter("GRIDSIZE") != null) ? Integer.parseInt(getParameter("GRIDSIZE")) : 10;
		entry = new String[gridsize][gridsize]; 

		this.resize(squaresize*gridsize+225,squaresize*gridsize);

		roo = this.size();
		bufimage = createImage(squaresize*gridsize+225,squaresize*gridsize);
		bufgraphic = bufimage.getGraphics();

		wordlist = getParameter("WORDLIST");
		st = new StringTokenizer(wordlist);
		title = (getParameter("LISTNAME") != null) ? getParameter("LISTNAME") : "WORD LIST";

		number = st.countTokens();
		words = new String[number];
		placedwords = new String[number];
		foundwords = new boolean[number];

		for (int i=0;i<number;i++) {
			foundwords[i] = false;
		}

		for (int i=0;i<number;i++) {
			words[i] = st.nextToken();
		}

		drawnloop = new int[number][4];

		placeWords();

		for (int i=0;i<gridsize;i++) {
			for (int j=0;j<gridsize;j++) {

		char r = (char)(int)(26*Math.random()+65);
		entry[i][j] = (entry[i][j] == null) ? String.valueOf(r) : entry[i][j];
			}
		}

	}

	public void placeWords() {
		int i=0;
		while (i<number && attempts < 5000) {
			attempts ++;
			double total = n+ne+e+se+s+sw+w+nw+1;
			switch ((int)(1+Math.random()*8)) {
				default : { dx=dy=px=py=0; break; }
				case 1 : {
					if (n<total/6) {
					dx=0;dy=-1;
					px = (int)(Math.random()*gridsize);
					py = (int)(Math.random()*(gridsize-words[i].length()))+words[i].length();
					if (putWord(i,dx,dy,px,py)) { n++;i++; }
					break;
					}
				}
				case 2 : {
					if (ne<total/6) {
					dx=1;dy=-1;
					px = (int)(Math.random()*(gridsize-words[i].length()));
					py = (int)(Math.random()*(gridsize-words[i].length()))+words[i].length();
					if (putWord(i,dx,dy,px,py)) { ne++;i++; }
					break;
					}
				}
				case 3 : {
					if (e<total/6) {
					dx=1;dy=0;
					px = (int)(Math.random()*(gridsize-words[i].length()));
					py = (int)(Math.random()*gridsize);
					if (putWord(i,dx,dy,px,py)) { e++;i++; }
					break;
					}
				}
				case 4 : {
					if (se<total/6) {
					dx=1;dy=1;
					px = (int)(Math.random()*(gridsize-words[i].length()));
					py = (int)(Math.random()*(gridsize-words[i].length()));
					if (putWord(i,dx,dy,px,py)) { se++;i++; }
					break;
					}
				}
				case 5 : {
					if (s<total/6) {
					dx=0;dy=1;
					px = (int)(Math.random()*gridsize);
					py = (int)(Math.random()*(gridsize-words[i].length()));
					if (putWord(i,dx,dy,px,py)) { s++;i++; }
					break;
					}
				}
				case 6 : {
					if (sw<total/6) {
					dx=-1;dy=1;
					px = (int)(Math.random()*(gridsize-words[i].length()))+words[i].length();
					py = (int)(Math.random()*(gridsize-words[i].length()));
					if (putWord(i,dx,dy,px,py)) { sw++;i++; }
					break;
					}
				}
				case 7 : {
					if (w<total/6) {
					dx=-1;dy=0;
					px = (int)(Math.random()*(gridsize-words[i].length()))+words[i].length();
					py = (int)(Math.random()*gridsize);
					if (putWord(i,dx,dy,px,py)) { w++;i++; }
					break;
					}
				}
				case 8 : {
					if (nw<total/6) {
					dx=-1;dy=-1;
					px = (int)(Math.random()*(gridsize-words[i].length()))+words[i].length();
					py = (int)(Math.random()*(gridsize-words[i].length()))+words[i].length();
					if (putWord(i,dx,dy,px,py)) { nw++;i++; }
					break;
					}
				}
			}
		}
	}

	public boolean putWord(int i, int dx, int dy, int px, int py) {
		String tempentry[] = new String[words[i].length()];
		for (int j=0;j<words[i].length();j++) {
//System.out.println(words[i]+","+j+" looking at spot:"+px+","+py+" with direction:"+ dx+","+dy);
			String hopeful = words[i].substring(j,j+1);
			if (entry[px+j*dx][py+j*dy] == null || entry[px+j*dx][py+j*dy].equals(hopeful.toUpperCase())) {
				tempentry[j] = hopeful.toUpperCase();

				if (j == words[i].length()-1) {
					for (int k=0;k<words[i].length();k++) {
						entry[px+k*dx][py+k*dy] = tempentry[k];
					}
					placedwords[i] = words[i];
					return true;
				}
			}
			else return false;
		}
		return false;
	}

	public void update(Graphics g) {
		paint(g);
	}

	public void paint(Graphics goo) {
		paintBuffer(bufgraphic);
		goo.drawImage(bufimage,0,0,this);
	}

	public void paintBuffer(Graphics g) {

		g.clearRect(0,0,squaresize*gridsize+225,squaresize*gridsize);

		g.setColor(Color.lightGray);
		g.fillRect(0,0,squaresize*gridsize+225,squaresize*gridsize);
		g.setColor(new Color(110,110,110));
		g.drawLine(0,0,0,squaresize*gridsize-1);
		g.drawLine(0,0,squaresize*gridsize-1,0);
		g.setColor(new Color(230,230,230));
		g.drawLine(0,squaresize*gridsize-1,squaresize*gridsize-1,squaresize*gridsize-1);
		g.drawLine(squaresize*gridsize-1,0,squaresize*gridsize-1,squaresize*gridsize-1);

		g.setColor(Color.black);

		g.setFont(new Font("courier",0,fontsize));
		for (int i=0;i<gridsize;i++) {
			for (int j=0;j<gridsize;j++) {
		g.drawString(String.valueOf(entry[i][j]),i*squaresize+squaresize/2-3,j*squaresize+squaresize/2+5);
			}
		}

		int total = 0;
		g.setFont(new Font("courier",0,fontsize));
		g.setColor(Color.blue);
		for (int i=0;i<placedwords.length;i++) {
			if (placedwords[i] != null && !foundwords[i]) { g.drawString(placedwords[i],squaresize*gridsize+15,(squaresize-8)*total+30); total++; }
		}

		g.setFont(new Font("courier",1,fontsize));
		g.setColor(new Color(170,50,50));
		g.drawString(title+" ("+String.valueOf(total)+")",squaresize*gridsize+15,15);

		g.setColor(Color.yellow);

		if (loopstart && loopcount<placedwords.length) {
			int x1 = tmploopx1;
			int y1 = tmploopy1;
			int x2 = tmploopx2;
			int y2 = tmploopy2;

			drawLoop (g,x1,y1,x2,y2);

		}
		g.setColor(Color.black);

		for (int i=0;i<loopcount;i++) {
			drawLoop (g,drawnloop[i][0],drawnloop[i][1],drawnloop[i][2],drawnloop[i][3]);
		}


	}

	public void drawLoop(Graphics g, int x1, int y1, int x2, int y2) {
			int angle = calculateAngle(x1,y1,x2,y2);
			int angle90 = (angle+90)%360;
			int angle270 = (angle+270)%360;
		
			double rangle = angle*Math.PI/180;
			double rangle90 = angle90*Math.PI/180;
			double rangle270 = angle270*Math.PI/180;

			int nx1 = (int)(x1+squaresize/2+Math.cos(rangle90)*loopsize/2);
			int ny1 = (int)(y1+squaresize/2-Math.sin(rangle90)*loopsize/2);
			int nx2 = (int)(x2+squaresize/2+Math.cos(rangle270)*loopsize/2);
			int ny2 = (int)(y2+squaresize/2-Math.sin(rangle270)*loopsize/2);

			int nx3 = (int)(x1+squaresize/2+Math.cos(rangle270)*loopsize/2);
			int ny3 = (int)(y1+squaresize/2-Math.sin(rangle270)*loopsize/2);
			int nx4 = (int)(x2+squaresize/2+Math.cos(rangle90)*loopsize/2);
			int ny4 = (int)(y2+squaresize/2-Math.sin(rangle90)*loopsize/2);

			g.drawArc(x1+(squaresize-loopsize)/2,y1+(squaresize-loopsize)/2,loopsize,loopsize,(angle90),180);
			g.drawArc(x2+(squaresize-loopsize)/2,y2+(squaresize-loopsize)/2,loopsize,loopsize,(angle270),180);
			
			g.drawLine(nx1,ny1,nx4,ny4);
			g.drawLine(nx3,ny3,nx2,ny2);
	}

	public int calculateAngle(int x1, int y1, int x2, int y2) {
			int angle = (int)(Math.atan((double)(y2-y1)/(x1-x2))*180/Math.PI);

			if (x2 > x1) {
				if (y1 == y2) { angle = 0; }
				else if (y2 > y1) { angle = angle+360;}
			}
			else { angle = angle+180; }
			return angle;
	}

	public boolean mouseDown(Event evt, int mx, int my) {

		if (mx < squaresize*gridsize && mx > 0 && my < squaresize*gridsize && my > 0) {
		loopstart = true;

		tmploopx1 = squaresize*(int)(mx/squaresize);
		tmploopy1 = squaresize*(int)(my/squaresize);
		tmploopx2 = squaresize*(int)(mx/squaresize);
		tmploopy2 = squaresize*(int)(my/squaresize);
		repaint();
		}

		return true;
	}

	public boolean mouseDrag(Event evt, int mx, int my) {

		if (mx < squaresize*gridsize && mx > 0 && my < squaresize*gridsize && my > 0) {

		tmploopx2 = squaresize*(int)(mx/squaresize);
		tmploopy2 = squaresize*(int)(my/squaresize);
		repaint();
		}

		return true;
	}

	public boolean mouseUp(Event evt, int mx, int my) {

		int bx = tmploopx1/squaresize;
		int by = tmploopy1/squaresize;
		int ex = tmploopx2/squaresize;
		int ey = tmploopy2/squaresize;

		if (bx == ex || by == ey || Math.abs(bx-ex) == Math.abs(by-ey)) {

			String test = "!";
			String testrev = "!";
			int ddx,ddy;

			if (bx == ex) ddx = 0;
			else if (bx > ex) ddx = -1;
			else ddx = 1;

			if (by == ey) ddy = 0;
			else if (by > ey) ddy = -1;
			else ddy = 1;

			for (int i=0;i<Math.max(Math.abs(bx-ex),Math.abs(by-ey))+1;i++) {
				test = test.concat(entry[bx+i*ddx][by+i*ddy]);
			}

			for (int i=0;i<Math.max(Math.abs(bx-ex),Math.abs(by-ey))+1;i++) {
				testrev = testrev.concat(entry[ex-i*ddx][ey-i*ddy]);
			}


			for (int i=0;i<words.length;i++) {
				if (words[i].toUpperCase().equals(test.substring(1)) || words[i].toUpperCase().equals(testrev.substring(1))) {
					drawnloop[loopcount][0] = tmploopx1;
					drawnloop[loopcount][1] = tmploopy1;
					drawnloop[loopcount][2] = tmploopx2;
					drawnloop[loopcount][3] = tmploopy2;

					soundoff = false;
					foundwords[i] = true;
					loopcount++;
					repaint();
					if (loopcount == placedwords.length) playFinale();
				}
			}
		}
		if (soundoff) noword.play();
		soundoff =true;
		return true;
	}

	public void playFinale() {
		win.play();
		try {Thread.sleep(5000);} catch (InterruptedException e){};
		loopcount = 0;
		init();
	}

}
